uniform sampler2D depthtex0;
uniform mat4 dhProjectionInverse;

vec3 get_view_position(vec2 coords) {
    float depth = texture(depthtex0, coords).r;
    vec4 screenPos = vec4(coords.x * 2.0 - 1.0, coords.y * 2.0 - 1.0, depth * 2.0 - 1.0, 1.0);
    vec4 viewPos = dhProjectionInverse * screenPos;
    viewPos.xyz = viewPos.xyz / viewPos.w;
    return vec3(viewPos.xyz);
}