in vec2 lightCoord;
in vec2 texCoord;
in vec3 normal;
in vec4 vertexColor;

uniform vec3 fogColor;
uniform sampler2D gtexture;
uniform sampler2D lightmap;

layout(location = 0) out vec4 pixelColor;

void main() {
	vec4 texColor = texture(gtexture, texCoord);
	if (texColor.a < 0.1) discard;
	vec4 lightColor = texture(lightmap, lightCoord);
	float nDotL = max(0.5, dot(normal, vec3(-3, 3, 1))/3.8);
	vec4 finalColor = texColor * vertexColor * lightColor * lightColor;
	pixelColor = vec4(finalColor.rgb*nDotL + fogColor/10, finalColor.a);
}