#version 330 compatibility

in vec2 lightCoord;
in vec4 vertexColor;
in float vertexDistance;

uniform sampler2D gtexture;
uniform sampler2D lightmap;

uniform float fogStart;
uniform float fogEnd;
uniform vec3 fogColor;

layout(location = 0) out vec4 pixelColor;

void main() {
	vec4 lightColor = texture(lightmap, lightCoord);
	float fogValue = vertexDistance < fogEnd ? smoothstep(fogStart, fogEnd, vertexDistance) : 1.0;
	fogValue = min(fogValue+(vertexDistance )/100, 1);
	vec4 finalColor =  vertexColor * lightColor + vec4(1, 1, 1, 0);
	pixelColor = vec4( mix(finalColor.xyz, fogColor, fogValue), finalColor.a);
}